???File Path
==========
***...\Models\corporate\CorporateModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@  CorporateCustomData  @@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlCorporateCustomData : MdlUserAction {

	public long binCorporateCustomDataId { get; set; } = 0;
	
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(50)]
	[Display(Name = "Sys Attribute Name")]
	public string strSysAttributeName { get; set; } = "";
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(50)]
	[Display(Name = "Attribute Label")]
	public string strAttributeLabel { get; set; } = "";
	public short sinCategory { get; set; } = 1;
	public short sinSubCategory { get; set; } = 1;
	public short sinInputBasedOn { get; set; } = 1;
	public short sinDataType { get; set; } = 1;
	public short sinWidgetType { get; set; } = 1;
	public string[] artSelectItems { get; set; } = Array.Empty<string>();
	public string strDbArtSelectItems { get; set; } = "";
	public short sinUseInSetRule { get; set; } = 0;
	
	public string strRemarks { get; set; } = "";
	public short sinRecordStatus { get; set; } = 1;
	public short sinOrder { get; set; } = 1;
	
}

public class MdlReqCorporateCustomData : MdlRequest {

	public MdlCorporateCustomData mdlCorporateCustomData { get; set; } = new MdlCorporateCustomData();
}

public class MdlResCorporateCustomData : MdlResponse {

	public MdlCorporateCustomData mdlCorporateCustomData { get; set; } = new MdlCorporateCustomData();
}

public class MdlResCorporateCustomDataList : MdlResponse {

	public List<MdlCorporateCustomData> lstMdlCorporateCustomData { get; set; } = new List<MdlCorporateCustomData>();
}

public class MdlResCorporateCustomDataInit : MdlResponse {


	public List<MdlCorporateCustomData> lstMdlCorporateCustomData { get; set; } = new List<MdlCorporateCustomData>();
}

