???File Path
==========
***...\Src\Corporate\CorporateCustomData.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Corporate;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllCorporateCustomDataBaseData()
            {
                List<MdlBaseIntId> lstMdlCorporateCustomDataBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_corporate_custom_data()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_corporate_custom_data_id"]) ? (long)Convert.ToUInt64(objRecord["pk_corporate_custom_data_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord["vhr_sys_attribute_name"]) ? Convert.ToString(objRecord["vhr_sys_attribute_name"]) : mdlBaseIntId.strName;
        
                        lstMdlCorporateCustomDataBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlCorporateCustomDataBaseIntId;
            }
        


            public List<MdlCorporateCustomData> FnGetAllCorporateCustomDataWithActionUser()
            {
                List<MdlCorporateCustomData> lstMdlCorporateCustomData = new List<MdlCorporateCustomData>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_corporate_custom_data_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlCorporateCustomData mdlCorporateCustomData = new MdlCorporateCustomData();

                        
				mdlCorporateCustomData.binCorporateCustomDataId = (DBNull.Value != objRecord["pk_corporate_custom_data_id"]) ? (long)Convert.ToInt64(objRecord["pk_corporate_custom_data_id"]) : mdlCorporateCustomData.binCorporateCustomDataId;

				mdlCorporateCustomData.strSysAttributeName = (DBNull.Value != objRecord["vhr_sys_attribute_name"]) ? Convert.ToString(objRecord["vhr_sys_attribute_name"]) : mdlCorporateCustomData.strSysAttributeName;
				mdlCorporateCustomData.strAttributeLabel = (DBNull.Value != objRecord["vhr_attribute_label"]) ? Convert.ToString(objRecord["vhr_attribute_label"]) : mdlCorporateCustomData.strAttributeLabel;
				mdlCorporateCustomData.sinCategory = (DBNull.Value != objRecord["sin_category"]) ? (short)Convert.ToInt16(objRecord["sin_category"]) : mdlCorporateCustomData.sinCategory;
				mdlCorporateCustomData.sinSubCategory = (DBNull.Value != objRecord["sin_sub_category"]) ? (short)Convert.ToInt16(objRecord["sin_sub_category"]) : mdlCorporateCustomData.sinSubCategory;
				mdlCorporateCustomData.sinInputBasedOn = (DBNull.Value != objRecord["sin_input_based_on"]) ? (short)Convert.ToInt16(objRecord["sin_input_based_on"]) : mdlCorporateCustomData.sinInputBasedOn;
				mdlCorporateCustomData.sinDataType = (DBNull.Value != objRecord["sin_data_type"]) ? (short)Convert.ToInt16(objRecord["sin_data_type"]) : mdlCorporateCustomData.sinDataType;
				mdlCorporateCustomData.sinWidgetType = (DBNull.Value != objRecord["sin_widget_type"]) ? (short)Convert.ToInt16(objRecord["sin_widget_type"]) : mdlCorporateCustomData.sinWidgetType;
				mdlCorporateCustomData.artSelectItems = (DBNull.Value != objRecord["art_select_items"]) ? (string[])objRecord["art_select_items"] : mdlCorporateCustomData.artSelectItems;
				mdlCorporateCustomData.sinUseInSetRule = (DBNull.Value != objRecord["sin_use_in_set_rule"]) ? (short)Convert.ToInt16(objRecord["sin_use_in_set_rule"]) : mdlCorporateCustomData.sinUseInSetRule;

				mdlCorporateCustomData.strRemarks = (DBNull.Value != objRecord["txt_remarks"]) ? Convert.ToString(objRecord["txt_remarks"]) : mdlCorporateCustomData.strRemarks;
				mdlCorporateCustomData.sinRecordStatus = (DBNull.Value != objRecord["sin_record_status"]) ? (short)Convert.ToInt16(objRecord["sin_record_status"]) : mdlCorporateCustomData.sinRecordStatus;
				mdlCorporateCustomData.sinOrder = (DBNull.Value != objRecord["sin_order"]) ? (short)Convert.ToInt16(objRecord["sin_order"]) : mdlCorporateCustomData.sinOrder;


				mdlCorporateCustomData.intSysActionId = (DBNull.Value != objRecord["int_sys_action_id"]) ? (int)Convert.ToInt32(objRecord["int_sys_action_id"]) : mdlCorporateCustomData.intSysActionId;
				mdlCorporateCustomData.binCreatedUserId = (DBNull.Value != objRecord["fk_created_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_created_user_id"]) : mdlCorporateCustomData.binCreatedUserId;
				mdlCorporateCustomData.strCreatedUser = this.insDbService.FnGetValue(objRecord["vhr_created_user"], mdlCorporateCustomData.strCreatedUser);
				mdlCorporateCustomData.dtmCreated = (DBNull.Value != objRecord["dtm_created"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_created"]) : mdlCorporateCustomData.dtmCreated;
				mdlCorporateCustomData.binLastModifiedUserId = (DBNull.Value != objRecord["fk_last_modified_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_last_modified_user_id"]) : mdlCorporateCustomData.binLastModifiedUserId;
				mdlCorporateCustomData.strLastModifiedUser = this.insDbService.FnGetValue(objRecord["vhr_last_modified_user"], mdlCorporateCustomData.strLastModifiedUser);
				mdlCorporateCustomData.dtmLastModified = (DBNull.Value != objRecord["dtm_last_modified"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_last_modified"]) : mdlCorporateCustomData.dtmLastModified;
				mdlCorporateCustomData.binDeletedUserId = (DBNull.Value != objRecord["fk_deleted_user_id"]) ? (long)Convert.ToInt64(objRecord["fk_deleted_user_id"]) : mdlCorporateCustomData.binDeletedUserId;
				mdlCorporateCustomData.strDeletedUser = this.insDbService.FnGetValue(objRecord["vhr_deleted_user"], mdlCorporateCustomData.strDeletedUser);
				mdlCorporateCustomData.dtmDeleted = (DBNull.Value != objRecord["dtm_deleted"]) ? (DateTime)Convert.ToDateTime(objRecord["dtm_deleted"]) : mdlCorporateCustomData.dtmDeleted;

        
                        lstMdlCorporateCustomData.Add(mdlCorporateCustomData);
                    }
                }

                return lstMdlCorporateCustomData;
            }
        


            public MdlResCorporateCustomData FnInsertOrUpdateCorporateCustomData(MdlReqCorporateCustomData mdlReqCorporateCustomData)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqCorporateCustomData.mdlCorporateCustomData.binCorporateCustomDataId == 0)
                {
                    mdlReqCorporateCustomData.mdlCorporateCustomData.intSysActionId = 0;
                    mdlReqCorporateCustomData.mdlCorporateCustomData.binCreatedUserId = mdlReqCorporateCustomData.linLoginUserId;
                    mdlReqCorporateCustomData.mdlCorporateCustomData.strCreatedUser = mdlReqCorporateCustomData.strLoginUserName;
                    mdlReqCorporateCustomData.mdlCorporateCustomData.dtmCreated = mdlReqCorporateCustomData.dtmCurrentDateTime;
                }
                else {
                    mdlReqCorporateCustomData.mdlCorporateCustomData.binLastModifiedUserId = mdlReqCorporateCustomData.linLoginUserId;
                    mdlReqCorporateCustomData.mdlCorporateCustomData.strLastModifiedUser = mdlReqCorporateCustomData.strLoginUserName;
                    mdlReqCorporateCustomData.mdlCorporateCustomData.dtmLastModified = mdlReqCorporateCustomData.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlCorporateCustomData", NpgsqlDbType.Jsonb) { Value = mdlReqCorporateCustomData.mdlCorporateCustomData, DataTypeName = "jsnCorporateCustomData"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_corporateCustomData(:mdlCorporateCustomData, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMDATA.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMDATA.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMDATA.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResCorporateCustomData mdlResCorporateCustomData = new MdlResCorporateCustomData();
                mdlResCorporateCustomData.mdlCorporateCustomData = mdlCorporateCustomDataReq.mdlCorporateCustomData;
                if (mdlReqCorporateCustomData.mdlCorporateCustomData.binCorporateCustomDataId == 0)
                {
                    mdlResCorporateCustomData.mdlCorporateCustomData.binCorporateCustomDataId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResCorporateCustomData.mdlCorporateCustomData.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResCorporateCustomData.mdlCorporateCustomData.intSysActionId += 1;
                    mdlResCorporateCustomData.mdlCorporateCustomData.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResCorporateCustomData.sinStatus = 1;
                mdlResCorporateCustomData.strStatusCode = "SUCCESS";
                mdlResCorporateCustomData.strMessage = "CORPORATECUSTOMDATA has been Saved.";
                
                return mdlResCorporateCustomData;
            } 
        


            public MdlResBaseIntId FnDeleteCorporateCustomData(MdlReqBaseIntId mdlReqCorporateCustomDataBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binCorporateCustomDataId", NpgsqlDbType.Bigint) { Value = mdlReqCorporateCustomDataBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binCorporateCustomDataId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqCorporateCustomDataBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqCorporateCustomDataBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_corporateCustomData(:binCorporateCustomDataId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMDATA.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMDATA.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CORPORATECUSTOMDATA.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResCorporateCustomDataIntId = new MdlResBaseIntId();

                mdlResCorporateCustomDataIntId.mdlBaseIntId = mdlReqCorporateCustomDataBaseIntId.mdlBaseIntId;
                mdlResCorporateCustomDataIntId.sinStatus = 1;
                mdlResCorporateCustomDataIntId.strStatusCode = "SUCCESS";
                mdlResCorporateCustomDataIntId.strMessage = "CORPORATECUSTOMDATA has been deleted.";

                return mdlResCorporateCustomDataIntId;
            }
        

