???File Path
==========
***...\ClientApp\srcpp\src\corporate\corporate-custom-data\corporate-custom-data.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlCorporateCustomData, MdlReqCorporateCustomData, MdlResCorporateCustomData, MdlResCorporateCustomDataInit, MdlResCorporateCustomDataList } from '../../../models/corporate/corporate.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class CorporateCustomDataComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlCorporateCustomData: MdlCorporateCustomData = new MdlCorporateCustomData();
                public intActiveCorporateCustomDataIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** CorporateCustomData List
                @ViewChild('#idDgCorporateCustomDataList') idDgCorporateCustomDataList!: DxDataGridComponent;
                public lstAllCorporateCustomData: MdlCorporateCustomData[] = [];
                public blnDgCorporateCustomDataShowFilterRow: boolean = false;
                public blnDgCorporateCustomDataHeaderFilter: boolean = false;
                public intActiveCorporateCustomDataListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'corporateCustomData';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "CORPORATECUSTOMDATA_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("CorporateCustomData");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetCorporateCustomDataInitializeData')
                    .then((mdlResCorporateCustomDataInit: MdlResCorporateCustomDataInit) => {
                        if (mdlResCorporateCustomDataInit.sinStatus == 1) {
                            this.lstMdlCorporateCustomData = mdlResCorporateCustomDataInit.lstMdlCorporateCustomData;

                            // ??? Remove not use items !!!

                        } else {
                            console.log(mdlResCorporateCustomDataInit.strMessage + " => " + mdlResCorporateCustomDataInit.strErrorCode + ' -> ' + mdlResCorporateCustomDataInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->CORPORATECUSTOMDATA.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnCorporateCustomDataListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnCorporateCustomDataListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlCorporateCustomData);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqCorporateCustomData: MdlReqCorporateCustomData = new MdlReqCorporateCustomData();
            mdlReqCorporateCustomData.mdlCorporateCustomData = JSON.parse(JSON.stringify(this.mdlCorporateCustomData));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveCorporateCustomData', mdlReqCorporateCustomData)
                .then((mdlResCorporateCustomData: MdlResCorporateCustomData) => {
                if (mdlResCorporateCustomData.sinStatus == 1) {
                    this.mdlCorporateCustomData = mdlResCorporateCustomData.mdlCorporateCustomData;
                    if (this.intActiveCorporateCustomDataIndex == -1) {
                    // New Item
                    this.intActiveCorporateCustomDataIndex = this.lstMdlCorporateCustomData.length;
                    this.lstMdlCorporateCustomData.push(JSON.parse(JSON.stringify(this.mdlCorporateCustomData)));
                    }
                    else {
                    // Update
                    this.lstMdlCorporateCustomData[this.intActiveCorporateCustomDataIndex] = JSON.parse(JSON.stringify(this.mdlCorporateCustomData));
                    //this.lstMdlCorporateCustomData.splice(this.intActiveCorporateCustomDataIndex, 1, this.mdlCorporateCustomData);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResCorporateCustomData.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResCorporateCustomData.strMessage, mdlResCorporateCustomData.strSysError);
                    console.log(mdlResCorporateCustomData);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->CORPORATECUSTOMDATA.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlCorporateCustomData.binCorporateCustomDataId == null || this.mdlCorporateCustomData.binCorporateCustomDataId < 1) {
                throw new Error('Select CorporateCustomData for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqCorporateCustomDataBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqCorporateCustomDataBaseIntId.mdlBaseIntId.binPkId = this.mdlCorporateCustomData.binCorporateCustomDataId;
            mdlReqCorporateCustomDataBaseIntId.mdlBaseIntId.binCustomValue = this.mdlCorporateCustomData.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteCorporateCustomData', mdlReqCorporateCustomDataBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlCorporateCustomData.splice(this.intActiveCorporateCustomDataIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->CORPORATECUSTOMDATA.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlCorporateCustomData = new MdlCorporateCustomData();
                    this.intActiveCorporateCustomDataIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlCorporateCustomData: MdlCorporateCustomData, intRowIndex: number) {
                this.mdlCorporateCustomData = JSON.parse(JSON.stringify(mdlCorporateCustomData));
                this.intActiveCorporateCustomDataIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlCorporateCustomData: MdlCorporateCustomData) {
                // ??? CHECK
                
                if (mdlCorporateCustomData.strSysAttributeName == "") {
                    throw new Error('Enter/Select Sys Attribute Name.');
                }
            
                if (mdlCorporateCustomData.strAttributeLabel == "") {
                    throw new Error('Enter/Select Attribute Label.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

